package controller;

import model.*;
import view.itemViewForm;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class itemController {

    private itemViewForm view;
    private Item model;
    private Register registerRef;
    private homeController homeControllerRef;

    public itemController(itemViewForm view, Item model, Register registerRef, homeController homeControllerReg){
        this.view = view;
        this.model = model;
        this.registerRef = registerRef;
        this.homeControllerRef = homeControllerReg;

        updateItemDisplay();

        this.view.form.getCancelButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                view.dispose();
            }
        });
        this.view.form.getAddButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                registerRef.getActiveOrder().addItem(model);
                homeControllerReg.updateOrderDisplay();
                view.dispose();
            }
        });

        if(model.getName() == "Burger" || model.getName() == "Double Burger"){
            view.form.getColaButton().setVisible(false);
            view.form.getDietColaButton().setVisible(false);
            view.form.getLemonLimeButton().setVisible(false);
            view.form.getRootBeerButton().setVisible(false);
            view.form.getNOSALTButton().setVisible(false);
            view.form.getBaconFry050Button().setVisible(false);
            view.form.getCheeseFryButton().setVisible(false);
        }else if(model.getName() == "Hot Dog"){
            view.form.getColaButton().setVisible(false);
            view.form.getDietColaButton().setVisible(false);
            view.form.getLemonLimeButton().setVisible(false);
            view.form.getRootBeerButton().setVisible(false);
            view.form.getNOSALTButton().setVisible(false);
            view.form.getBaconFry050Button().setVisible(false);
            view.form.getCheeseFryButton().setVisible(false);
            view.form.getPicklesButton().setVisible(false);
            view.form.getCheese020Button().setVisible(false);
            view.form.getOnionButton().setVisible(false);
            view.form.getBacon200Button().setVisible(false);
            view.form.getMayoButton().setVisible(false);
            view.form.getMushrooms100Button().setVisible(false);
            view.form.getLettuceButton().setVisible(false);
            view.form.getTomatoButton().setVisible(false);
        }else if(model.getName() == "Grilled Cheese"){
            view.form.getColaButton().setVisible(false);
            view.form.getDietColaButton().setVisible(false);
            view.form.getLemonLimeButton().setVisible(false);
            view.form.getRootBeerButton().setVisible(false);
            view.form.getNOSALTButton().setVisible(false);
            view.form.getBaconFry050Button().setVisible(false);
            view.form.getCheeseFryButton().setVisible(false);
            view.form.getPicklesButton().setVisible(false);
            view.form.getCheese020Button().setVisible(false);
            view.form.getOnionButton().setVisible(false);
            view.form.getBacon200Button().setVisible(false);
            view.form.getMayoButton().setVisible(false);
            view.form.getMushrooms100Button().setVisible(false);
            view.form.getLettuceButton().setVisible(false);
            view.form.getTomatoButton().setVisible(false);
            view.form.getKetchupButton().setVisible(false);
            view.form.getMustardButton().setVisible(false);
            view.form.getNOBUNButton().setVisible(false);
        } else if (model.getName() == "Small Soda" || model.getName() == "Medium Soda" || model.getName() == "Large Soda"){
            view.form.getNOSALTButton().setVisible(false);
            view.form.getBaconFry050Button().setVisible(false);
            view.form.getCheeseFryButton().setVisible(false);
            view.form.getPicklesButton().setVisible(false);
            view.form.getCheese020Button().setVisible(false);
            view.form.getOnionButton().setVisible(false);
            view.form.getBacon200Button().setVisible(false);
            view.form.getMayoButton().setVisible(false);
            view.form.getMushrooms100Button().setVisible(false);
            view.form.getLettuceButton().setVisible(false);
            view.form.getTomatoButton().setVisible(false);
            view.form.getKetchupButton().setVisible(false);
            view.form.getMustardButton().setVisible(false);
            view.form.getNOBUNButton().setVisible(false);
        } else {
            view.form.getColaButton().setVisible(false);
            view.form.getDietColaButton().setVisible(false);
            view.form.getLemonLimeButton().setVisible(false);
            view.form.getRootBeerButton().setVisible(false);
            view.form.getPicklesButton().setVisible(false);
            view.form.getCheese020Button().setVisible(false);
            view.form.getOnionButton().setVisible(false);
            view.form.getBacon200Button().setVisible(false);
            view.form.getMayoButton().setVisible(false);
            view.form.getMushrooms100Button().setVisible(false);
            view.form.getLettuceButton().setVisible(false);
            view.form.getTomatoButton().setVisible(false);
            view.form.getKetchupButton().setVisible(false);
            view.form.getMustardButton().setVisible(false);
            view.form.getNOBUNButton().setVisible(false);
        }

        view.form.getCheese020Button().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                AddOn a = new AddOn(0, "Cheese", Money.parse(Currency.USD, .20));
                model.addAddOn(a);
                updateItemDisplay();
            }
        });
        view.form.getBacon200Button().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                AddOn a = new AddOn(0, "Bacon", Money.parse(Currency.USD, 2.0));
                model.addAddOn(a);
                updateItemDisplay();
            }
        });
        view.form.getKetchupButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                AddOn a = new AddOn(0, "Ketchup", Money.parse(Currency.USD, 0));
                model.addAddOn(a);
                updateItemDisplay();
            }
        });
        view.form.getMustardButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                AddOn a = new AddOn(0, "Mustard", Money.parse(Currency.USD, 0));
                model.addAddOn(a);
                updateItemDisplay();
            }
        });
        view.form.getMayoButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                AddOn a = new AddOn(0, "Mayo", Money.parse(Currency.USD, 0));
                model.addAddOn(a);
                updateItemDisplay();
            }
        });
        view.form.getLettuceButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                AddOn a = new AddOn(0, "Lettuce", Money.parse(Currency.USD, 0));
                model.addAddOn(a);
                updateItemDisplay();
            }
        });
        view.form.getTomatoButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                AddOn a = new AddOn(0, "Tomato", Money.parse(Currency.USD, 0));
                model.addAddOn(a);
                updateItemDisplay();
            }
        });
        view.form.getOnionButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                AddOn a = new AddOn(0, "Onion", Money.parse(Currency.USD, 0));
                model.addAddOn(a);
                updateItemDisplay();
            }
        });
        view.form.getPicklesButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                AddOn a = new AddOn(0, "Pickles", Money.parse(Currency.USD, 0));
                model.addAddOn(a);
                updateItemDisplay();
            }
        });
        view.form.getMushrooms100Button().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                AddOn a = new AddOn(0, "Mushrooms", Money.parse(Currency.USD, 1));
                model.addAddOn(a);
                updateItemDisplay();
            }
        });
        view.form.getNOBUNButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                AddOn a = new AddOn(0, "NO-BUN", Money.parse(Currency.USD, 0));
                model.addAddOn(a);
                updateItemDisplay();
            }
        });
        view.form.getNOSALTButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                AddOn a = new AddOn(0, "NO-SALT", Money.parse(Currency.USD, 0));
                model.addAddOn(a);
                updateItemDisplay();
            }
        });
        view.form.getCheeseFryButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                AddOn a = new AddOn(0, "Fry Cheese", Money.parse(Currency.USD, 0));
                model.addAddOn(a);
                updateItemDisplay();
            }
        });
        view.form.getBaconFry050Button().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                AddOn a = new AddOn(0, "Fry Bacon", Money.parse(Currency.USD, 0.5));
                model.addAddOn(a);
                updateItemDisplay();
            }
        });
        view.form.getColaButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(model.getName() == "Small Soda") {
                    model.setName("Small Cola");
                } else if (model.getName() == "Medium Soda"){
                    model.setName("Medium Cola");
                } else {
                    model.setName("Large Cola");
                }
                registerRef.getActiveOrder().addItem(model);
                homeControllerReg.updateOrderDisplay();
                view.dispose();
            }
        });
        view.form.getRootBeerButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(model.getName() == "Small Soda") {
                    model.setName("Small Root Beer");
                } else if (model.getName() == "Medium Soda"){
                    model.setName("Medium Root Beer");
                } else {
                    model.setName("Large Root Beer");
                }
                registerRef.getActiveOrder().addItem(model);
                homeControllerReg.updateOrderDisplay();
                view.dispose();
            }
        });
        view.form.getDietColaButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(model.getName() == "Small Soda") {
                    model.setName("Small Diet Cola");
                } else if (model.getName() == "Medium Soda"){
                    model.setName("Medium Diet Cola");
                } else {
                    model.setName("Large Diet Cola");
                }
                registerRef.getActiveOrder().addItem(model);
                homeControllerReg.updateOrderDisplay();
                view.dispose();
            }
        });
        view.form.getLemonLimeButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(model.getName() == "Small Soda") {
                    model.setName("Small Lemon Lime");
                } else if (model.getName() == "Medium Soda"){
                    model.setName("Medium Lemon Lime");
                } else {
                    model.setName("Large Lemon Lime");
                }
                registerRef.getActiveOrder().addItem(model);
                homeControllerReg.updateOrderDisplay();
                view.dispose();
            }
        });
    }

    private void updateItemDisplay(){
        view.form.getItemDetail().setText(model.toString());
    }

}
