package controller;

import model.Register;
import model.SQLConnection;
import view.homeViewForm;
import view.loginViewForm;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.SQLException;

public class loginController {
    private loginViewForm view;
    //private Register model;

    public loginController(loginViewForm view){
        this.view = view;
        //this.model = model;

        //view.form.getMessage().setVisible(false);
        view.form.getMessage().setForeground(Color.lightGray);

        view.form.getLoginButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

                if(!(view.form.getClientID() + view.form.getPasscode()).equals("")){
                    if (validLogin(view.form.getClientID(), view.form.getPasscode())) {
                        //view.form.getMessage().setText("Very Good");
                        //view.form.getMessage().setForeground(Color.GREEN);
                        /*
                         *
                         * PASSCODE MATCH | PASSCODE MATCH | PASSCODE MATCH |
                         *
                         */
                        openHome();
                    } else {
                        view.form.getMessage().setText("Incorrect Passcode or ClientID");
                        view.form.getMessage().setForeground(Color.RED);
                    }
                } else {
                    view.form.getMessage().setText("Please Provide ClientID and Passcode");
                    view.form.getMessage().setForeground(Color.ORANGE);
                }
                view.form.getMessage().setVisible(true);
            }
        });
    }

    private boolean validLogin(String clientID, String passcode) {
        boolean rtn = false;
        try {
            SQLConnection dataEngine = new SQLConnection();
            rtn = dataEngine.validLogin(clientID, passcode);
            dataEngine.terminateConnection();
        } catch (SQLException e){
            throw new RuntimeException(e);
        }
        return rtn;
    }

    private void openHome(){
        homeViewForm view = new homeViewForm();
        homeController controller = new homeController(view, new Register());
        view.setVisible(true);
        this.view.dispose();
    }
}
