package view;

import model.Order;
import model.Register;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class orderFinalViewForm extends JFrame {
    public orderFinalView form;
    private homeViewForm homeRef;
    private Register modelRef;

    public orderFinalViewForm(int id, String change, homeViewForm homeRef, Register modelRef){
        this.homeRef = homeRef;
        this.form = new orderFinalView();

        modelRef.addOrder(modelRef.getActiveOrder());

        JPanel content = form.getMaster();
        this.setContentPane(content);
        this.setSize(510, 200);
        this.setTitle("Finalize Order");
        this.setLocationRelativeTo(null);
        this.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);

        form.getOrderIDField().setText(Integer.toString(modelRef.getActiveOrder().getId()));
        form.getChangeField().setText(change.toString());


        form.getCloseButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                modelRef.setActiveOrder(new Order());
                homeRef.form.getOrderDetail().setText(modelRef.getActiveOrder().toString());
                homeRef.form.getTotalButton().setText("Total: " + modelRef.getActiveOrder().getTotal());
                dispose();
            }
        });

    }

}
