package model;

public class AddOn {
    private int id;
    private final String name;
    private Money price;

    public AddOn(int id, String name, Money price){
        this.id = id;
        this.name = name;
        this.price = price;
    }

    public AddOn(String name, Money price){
        // id already 0
        this.name = name;
        this.price = price;
    }

    public int getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    public Money getPrice() {
        return price;
    }

    @Override
    public String toString(){
        return name + " " + price;
    }
}
