package model;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Random;
import java.util.Scanner;

public class Tester {

    private static final Random rand = new Random();

    public static void main(String[] args) throws SQLException {

        /*
        SQLConnection dataEngine = new SQLConnection();

        dataEngine.refundOrder(1040);

        dataEngine.closeConnection();

         */

        /*
        SQLConnection dataEngine = new SQLConnection();

        Money m1 = new Money(0.1);
        Money m2 = new Money(5);
        Money m3 = new Money(2);
        Money m4 = new Money(20);

        AddOn a = new AddOn(0, "Cheese", m1);
        //System.out.println(a);

        Item i1 = new Item("Burger", m2, ItemCategory.FOOD);
        Item i2 = new Item("Fries", m3, ItemCategory.FOOD);
        Item i3 = new Item("T-Shirt", m4, ItemCategory.MERCHANDISE);
        i1.addAddOn(a);
        //System.out.println(i);

        Order o = new Order();
        o.addItem(i1);
        o.addItem(i1);
        o.addItem(i2);
        o.addItem(i3);

        System.out.println("Tax: " + Money.parse(Currency.USD, o.getTotal().castToDouble() * 0.06));
        System.out.println(o);

        dataEngine.recordOrder(o);


        Order order = dataEngine.getOrderById(4);
        System.out.println(order);

        dataEngine.closeConnection();
        */
    }





    public static Order randomOrder(){
        Order o = new Order(0);
        Money fryPrice = new Money(2,0);
        //public Item(String name, Money price, ItemCategory category)
        Item fry = new Item("Fries", fryPrice, ItemCategory.FOOD);

        int numBurgers = rand.nextInt(6) + 1;

        for (int i = 0; i < numBurgers; i++) {
            if(rand.nextBoolean()){
                o.addItem(fry);
            }
            o.addItem(randomBurger());
        }

        return o;
    }

    private static Item randomBurger() {
        Money five = new Money(5,0);
        Money tenC = new Money(0,10);
        Money oneD = new Money(1,0);
        Money zero = new Money(0,0);
        Item b = new Item("Burger", five, ItemCategory.FOOD);


        // AddOn(String name, Money price)
        AddOn ketchup = new AddOn("Ketchup", zero);
        AddOn cheese = new AddOn("Cheese", tenC);
        AddOn mayo = new AddOn("Mayo", zero);
        AddOn mustard = new AddOn("Mustard", zero);
        AddOn lettuce = new AddOn("Lettuce", zero);
        AddOn pickle = new AddOn("Pickle", zero);
        AddOn onion = new AddOn("Onion", zero);
        AddOn noBun = new AddOn("NO-BUN", zero);
        AddOn bacon = new AddOn("Bacon", zero);
        ArrayList<AddOn> addOns = new ArrayList<>();
        addOns.add(ketchup);
        addOns.add(cheese);
        addOns.add(mayo);
        addOns.add(mustard);
        addOns.add(lettuce);
        addOns.add(pickle);
        addOns.add(onion);
        addOns.add(noBun);
        addOns.add(bacon);

        int numAddOns = rand.nextInt(5);

        for (int i = 0; i < numAddOns; i++) {
            int next = rand.nextInt(addOns.size());
            b.addAddOn(addOns.get(next));
            addOns.remove(next);
        }

        return b;
    }
}
